﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SharpDX.Direct2D1;

namespace SFSpacefight
{
	public class MenuMain : Screen
	{
		public MenuMain(RenderTarget target)
			: base(target)
		{
			objects.Add(new Button(target, "New Game", 0, 400, 200, 25));
			objects.Add(new Button(target, "Load Game", 0, 450, 200, 25));
			objects.Add(new Button(target, "Options", 0, 500, 200, 25));
			objects.Add(new Button(target, "Quit", 0, 550, 200, 25));
		}
		public override GameState Loop(int mousex, int mousey, bool clicked)
		{
			GameState returnstate = base.Loop(mousex, mousey, clicked);

			if (returnstate == GameState.None)
				for (int i = 0; i < objects.Count; i++)
				{
					if (objects[i].Loop(mousex, mousey, clicked) == GameState.ButtonClicked)
					{
						switch (i)
						{
							case 0 : //new game
								progresscountdown = transitionframes;
								nextscreen = new MenuNew(mytarget);
								break;
							case 1: //load game
								nextscreen = new MenuLoad(mytarget);
								progresscountdown = transitionframes;
								break;
							case 2: //options
								nextscreen = new MenuOptions(mytarget);
								progresscountdown = transitionframes;
								break;
							case 3 : //quit
								returnstate = GameState.End;
								break;
						}
					}
				}

			return returnstate;
		}
	}
}